/*
 * main.cpp
 *
 *  Created on: May 16, 2009
 *      Author: michael
 */

#include "supporter.h"
#include <iostream>

using namespace std;



void print_usage(char * argv[])
{
    cerr << Supporter::name << ' ' << Supporter::version << " -- " << Supporter::author << endl;
    cerr << "USAGE:\t" << argv[0] << " datafile itemsets output" << endl;
    cerr << "   OR \t" << argv[0] << " datafile [--stats | --items]" << endl;
    cerr << "\tdatafile   :\ttransactional dataset in fimi format" << endl;
    cerr << "\titemsets   :\tfile with one itemset per line, or '-' for stdin" << endl;
    cerr << "\toutput     :\toutput file with itemsets and supports, or '-' for stdout" << endl;
    cerr << "\t--stats    :\tdisplay some datafile statistics" << endl;
    cerr << "\t--items    :\tprint all item supports" << endl;
	cerr << "\t-h, --help :\tprint this help" << endl;
	
	return;
}


int main(int argc, char *argv[]) {

	char *param_datafile = 0;
	char *param_itemsets = 0;
	char *param_output = 0;
	bool param_stats = false;
	bool param_items = false;

	for (int i=1; i<argc; ++i) {
		if (string(argv[i])==string("-h") || string(argv[i])==string("--help")) {
			print_usage(argv);
			return 1;
		}
	}

	if (argc < 3) {
		print_usage(argv);
		return 1;
	}
	else if (argc==3) {
		param_datafile = argv[1];
		if (string(argv[2]) == string("--stats") ) {
			param_stats = true;
		}
		else if (string(argv[2]) == string("--items")) {
			param_items = true;
		}
		else {
			print_usage(argv);
			return 1;
		}
	}
	else {
		param_datafile = argv[1];
		param_itemsets = argv[2];
		param_output   = argv[3];
	}


	Supporter supporter;

	supporter.set_datafile(param_datafile);
	supporter.read_data();
	if (param_itemsets && param_output) {
		supporter.set_itemsetfile(param_itemsets);
		supporter.set_outfile(param_output);
		supporter.run();
	}
	else if (param_stats) {
		supporter.stats();
	}
	else if (param_items) {
		supporter.singletons();
	}


	return 0;

}
