/*
 * supporter.h
 *
 *  Created on: May 16, 2009
 *      Author: michael
 */

#ifndef SUPPORTER_H_
#define SUPPORTER_H_

#include <string>
#include <map>
#include <vector>

using namespace std;


typedef unsigned int uint;


class Supporter
{
public:
	Supporter();
	~Supporter();

	void set_datafile(string filename)     { datafilename = filename; }
	void set_itemsetfile(string filename)  { itemsetfilename = filename; }
	void set_outfile(string filename)      { outfilename = filename; }

	void read_data();
	void make_all_tid_list();
	void run();

	void stats();
	void singletons();

	static const string name;
	static const string version;
	static const string author;


private:
	vector<int> *read_line(FILE *file, bool allow_negative=false);
	uint get_support(vector<int> &itemset);
	void cleanup();

	string datafilename;
	string itemsetfilename;
	string outfilename;

	uint trans_count;

	map<int, vector<uint>* > items;
	vector<uint> *all_tid_list;


};


#endif /* SUPPORTER_H_ */
